const kPersonalAddressbookURI = "moz-abmdbdirectory://abook.mab";
const kCollectedAddressbookURI = "moz-abmdbdirectory://history.mab";

function doTest() {
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);
  promptService.alert(null,'TEst', 'doTest');
}

function update() {

//// < 0.8.3  : Preferences aus globalem ldap_2.servers.xxx in unseren Bereich verschieben
  count=new Object();
  prefs=new Object();
  this.mPrefBranch.getChildList ( "ldap_2.servers", count , prefs );
  if (!count.value) {
//this.promptService.alert(null,'update', 'must update: count='+count.value);

    // get all MAB Files
    var mabs=new Object();
    var cn = this.directory.childNodes;
    var aBook = cn.getNext();
    while( aBook != null )
    {
      var dir = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = dir.directoryProperties ;
      var dirType = dirProp.dirType;
      if (dirType==2) {            // ignore ldap-addressbooks (dirType!=2)
        var prefName = dirProp.prefName;
        if (mabs[prefName])
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.description+'('+file+')\n');
//          this.promptService.alert(null,'update', 'nsIAbDirectory::childNodes returned double addressbook '+dirProp.description);
        else {
//          this.promptService.alert(null,'update', 'move '+dirProp.description);
          mabs[prefName]=dirProp;
          if (this.separateupdown) {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.up" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);

            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.down" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          } else {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          }
          try { sync = this.mGlobalPref.deleteBranch( prefName+".extensions.addressbookssync" ); }
            catch(e) { this.promptService.alert(null,'update', e); }
        }
      }
      try { aBook = cn.getNext(); } catch(e) { break; }
      this.mGlobalPref.savePrefFile(null);  //save to prefs.js
    } // while
  }
//else this.promptService.alert(null,'update', 'not updating');
//// Ende < 0.8.3
}

/*
 *  cleanup preferences
 */
function cleanup() {
  count=new Object();
  var prefs=this.mGlobalPref.getChildList("ldap_2.servers", count);
  var done=new Object();
  done['ldap_2.servers.default']=1;
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/(ldap_2.servers.[^.]+)\..+/,'$1');
    if (done[pref]) continue;
    done[pref]=1;
    try {
      this.mGlobalPref.getCharPref(pref+'.description');  //!!!!
    } catch(e) {
//this.promptService.alert(null, 'test', pref);
      try { sync = this.mGlobalPref.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  var prefs=this.mPrefBranch.getChildList("ldap_2.servers", count);
    //liefert _ALLE_keys
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/\.[^.]+$/,'');
    try {
      this.mGlobalPref.getCharPref(pref+'.description');
    } catch(e) {
      try { sync = this.mPrefBranch.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  this.mGlobalPref.savePrefFile(null);  //save to prefs.js

}

/*
 * returns list of mab to be synced
 */
function syncedAddressbooks(direction, singleBook)
{   //direction: up, down, all
  var mabs=new Object();
  var mabsArray=Components.classes["@mozilla.org/supports-array;1"]
         .createInstance(Components.interfaces.nsICollection);

  var cn = this.directory.childNodes;
  var aBook = cn.getNext();
  while( aBook != null )
  {
    var dir = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
    var dirProp = dir.directoryProperties ;
    var dirType = dirProp.dirType;
    if (dirType==2) {            // ignore ldap-addressbooks (dirType!=2)
      var sync=false;
      if (direction=='all')
        sync=true
      else if (singleBook && dirProp.fileName==singleBook)
        sync=true;
      else if (!singleBook) {
        var prefName = dirProp.prefName;
        try { sync = this.mPrefBranch.getBoolPref(prefName+'.'+direction); }
          catch(e) { sync=false; }
      }
      if (sync) {
        var file = dirProp.fileName;
        if (mabs[file])
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.description+'('+file+')\n');
        else {
          mabs[file]=true;
          mabsArray.AppendElement(dir);
        }
      }
    }
    try { aBook = cn.getNext(); } catch(e) { break; }
  } // while
  return mabsArray;
}

/*
 * return address book data structure associated with filename or description (=address book name)
 */
function getAddressBook( name )
{
  var cn = this.directory.childNodes;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    if( dir.directoryProperties.fileName == name || dir.directoryProperties.description == name) {
        return dir;
    }
  } // while
  return null;
} // getAddressBook

/*
 * create new address book
 */
function createAddressBook(name, fileName)
{
  try {
    var abProps = Components.classes["@mozilla.org/addressbook/properties;1"].
      createInstance(Components.interfaces.nsIAbDirectoryProperties);
    abProps.description = name;
    abProps.dirType = 2;
    abProps.fileName = fileName;
    this.directory.createNewDirectory( abProps );
    var dir=this.getAddressBook(fileName);
    return dir;
  } catch (e) {
this.promptService.alert(null, 'ERROR', 'createAddressBook('+name+','+fileName+')\n'+e);
    return null;
  }
} // createAddressBook

/*
 * delete an address book
 */
function deleteAddressBook( name, fileName )
{
  // Move focus away from the to be deleted addressbook
    // this has to be done in the AddressBook window :-((
//  try {  SetAbView(kPersonalAddressbookURI, false);} catch(e) { alert(e);}

  try {
    var dir=this.getAddressBook(fileName);
    if (dir && dir.directoryProperties.URI!=kPersonalAddressbookURI &&
          dir.directoryProperties.URI!=kCollectedAddressbookURI) {
      var prefName = dir.directoryProperties.prefName;
        //prefName='ldap_2.servers.name' mit name='history', 'pab' oder eigener
      this.directory.deleteDirectory( dir );
      this.mGlobalPref.clearUserPref( prefName+'.position' );  // sometimes remains!?
      this.mGlobalPref.deleteBranch( prefName );
      return true;
    }
  } catch (e) {
this.promptService.alert(null, 'ERROR', 'deleteAddressBook('+name+','+fileName+')\n'+e);
    return false;
  }
} // deleteAddressBook

